#!/bin/bash

function install_sshpass() {
    log_info "install package sshpass."
    dpkg -i "${install_path}"/Install_Packages/ubuntu22.04_deb/sshpass_1.06-1_amd64.deb
}

function install_expect() {
    log_info "install package expect."
    dpkg -i "${install_path}"/Install_Packages/ubuntu22.04_deb/libtcl8.6_8.6.8+dfsg-3_amd64.deb
    dpkg -i "${install_path}"/Install_Packages/ubuntu22.04_deb/tcl-expect_5.45.4-1_amd64.deb
    dpkg -i "${install_path}"/Install_Packages/ubuntu22.04_deb/expect_5.45.4-1_amd64.deb
}

function install_fio() {
    # install fio
    log_info "install package fio"
    for _ip in ${IP_LIST[@]}; do
        $SCP "${install_path}"/Install_Packages/ubuntu22.04_deb/fio* root@${_ip}:/tmp/
        $SSH root@${_ip} "dpkg -i /tmp/fio-3.30.deb &> /dev/null"
	sleep 5
	$SSH root@${_ip} "dpkg -i /tmp/fio-3.2-X86_64.deb &> /dev/null"
	sleep 3
    done
}

function install_ntpdate() {
    log_info "install package ntpdate"
    for _ip in ${IP_LIST[@]}; do
	$SCP "${install_path}"/Install_Packages/ubuntu22.04_deb/python3* root@${_ip}:/tmp/
	$SCP "${install_path}"/Install_Packages/ubuntu22.04_deb/ntp* root@${_ip}:/tmp/
	$SCP "${install_path}"/Install_Packages/ubuntu22.04_deb/man-db* root@${_ip}:/tmp/
	sleep 5
	$SSH root@${_ip} "dpkg -i /tmp/python3-ntp_1.2.2+dfsg1-4build2_amd64.deb &> /dev/null"
	sleep 3
	$SSH root@${_ip} "dpkg -i /tmp/man-db_2.12.0-4build2_amd64.deb &> /dev/null"
	sleep 3
        $SSH root@${_ip} "dpkg -i /tmp/ntpsec-ntpdig_1.2.2+dfsg1-4build2_amd64.deb &> /dev/null"
	sleep 3
        $SSH root@${_ip} "dpkg -i /tmp/ntpsec-ntpdate_1.2.2+dfsg1-4build2_amd64.deb &> /dev/null"
	sleep 3
	$SSH root@${_ip} "dpkg -i /tmp/ntpdate_4.2.8.deb &> /dev/null"
	sleep 2
    done
}

function install_mc() {
    # install mc
    log_info "install s3 tool mc"
    \cp "${install_path}"/Install_Packages/mc /usr/local/sbin/
    chmod +x /usr/local/sbin/mc 
}

function install_nfs_server() {
    # install install_ipcalc
    log_info "install nfs"
    if ! $(which nfs &> /dev/null);then
	#apt autoremove -y nfs*
	#sleep 1
	#rm -rf /lib/systemd/system/nfs-*
	sleep 1
	#rm -rf /etc/systemd/system/nfs-*
	sleep 3
        dpkg -i "${install_path}"/Install_Packages/ubuntu22.04_deb/nfs/*
        sleep 3
        mkdir -p /data/nas/{esback,nfs}

        service rpcbind status | grep ""
        cat << EOF > /etc/exports
/data/nas/nfs *(rw,sync,no_root_squash)
/data/nas/esback *(rw,sync,no_root_squash)
EOF
        #exportfs -rv
        systemctl restart rpcbind
        #systemctl restart nfs-common.service
        systemctl restart nfs-utils.service
	systemctl restart nfs-kernel-server.service
	systemctl restart nfs-server
	sleep 3
	service nfs-utils status | grep ""
	service nfs-kernel-server status | grep ""
    fi
}

function install_requirements() {
    install_sshpass
    install_expect
    echo "================================================="
    source "${install_path}"/scripts/ssh_key_config.sh
    echo "================================================="
    sleep 3
    install_ntpdate
    install_nfs_server
    install_fio
    install_mc
}

install_requirements
